//
//  CSController.h
//  Chimera
//
//  Created by Simon Woodside on Fri Feb 28 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Appkit/Appkit.h>

@class BrowserWindowController;
@class BrowserWrapper;
@class CSDataSource;
@class CSFormatter;

@interface CSController : NSObject
{
  IBOutlet NSScrollView * scrollView;

  NSTextFieldCell * textFieldCell;
  CSFormatter * formatter;

  NSMutableDictionary * viewDict;
  CSDataSource * dataSource;

  id delegate;
}

- (void)setNeedsUpdate;

- (void)didOpenWindow:(BrowserWindowController *)aWindow;
- (void)willCloseWindow:(BrowserWindowController *)aWindow;

- (NSView *)viewForWindow:(BrowserWindowController *)bwc;

- (void)addCSWithBrowserWrapper:(BrowserWrapper *)bw;
- (void)removeCSWithBrowserWrapper:(BrowserWrapper *)bw;

//CHBrowserListener listeners
- (void)onLoadingStarted;
- (void)onLoadingCompleted:(BOOL)succeeded;
- (void)onLocationChange:(NSString*)urlSpec;

///FIXME!!!! (kind of delegates from some ns listener
- (void)onProgressChange:(int)currentBytes outOf:(int)maxBytes;
- (void)onStatusChange:(NSString*)aMessage;
- (void)onSecurityStateChange:(unsigned long)newState;
- (void)onShowTooltip:(NSPoint)where withText:(NSString*)text;
- (void)onHideTooltip;

//NSOutlineViewDataSource informal protocol methods
- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item;
- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item;
- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item;
- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;
- (void)outlineViewSelectionDidChange:(NSNotification *)notification;

@end
