//
//  CSFormatter.m
//  Chimera
//
//  Created by Simon Woodside on Sat Mar 15 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "CSFormatter.h"

#import "BrowserWrapper.h"

@implementation CSFormatter

// This formats BrowserWrapper objects into something that
// can be displayed in a tableView of some sort

- (NSString *)stringForObjectValue:(id)anObject;
{
  NSLog(@"(CSFormatter) -stringForObjectValue start");
  if (![anObject isKindOfClass:[NSString class]]) {
    return @"WHOOPSA";
  }
//  NSString * result = [(BrowserWrapper *)anObject title];
  NSLog(@"(CSFormatter) -stringForObjectValue done");
  return (NSString *)anObject; //result;
}

- (NSAttributedString *)attributedStringForObjectValue:(id)anObject
                                 withDefaultAttributes:(NSDictionary *)attributes;
{
  NSLog(@"(CSFormatter) -attributedStringForObjectValue enter");
  if (![anObject isKindOfClass:[BrowserWrapper class]]) {
    return nil;
  }
  //Get the string
  NSString * newString = [self stringForObjectValue:anObject];
  
  //Change the paragraph style to insert ... in the middle
  NSMutableDictionary * newAttrs =
    [[NSMutableDictionary dictionaryWithCapacity:10] retain];
  [newAttrs addEntriesFromDictionary:attributes];
  NSMutableParagraphStyle * newPS = [[NSMutableParagraphStyle alloc] init];
  [newPS setParagraphStyle:[newAttrs objectForKey:NSParagraphStyleAttributeName]];
  [newPS setLineBreakMode:NSLineBreakByTruncatingMiddle]; //10.2 ONLY!!!!!!!
  //not implemented yet, so...
  //use "toll-free bridging"
//  OSStatus err;
//  err = TruncateThemeText((CFMutableStringRef) text, kThemeViewsFont,
//                          kThemeStateActive, width, truncMiddle, NULL);
//  if (err != noErr) {
//    NSLog(@"TruncateThemeText failed with error %d", err);
//  }
  
  [newPS setLineBreakMode:NSLineBreakByClipping];
  [newAttrs setObject:newPS forKey:NSParagraphStyleAttributeName];

  NSAttributedString * result =
    [[NSAttributedString alloc] initWithString:newString attributes:newAttrs];
  NSLog(@"(CSFormatter) -attributedStringForObjectValue done");
  return result;
}
@end
